// (C) 2017-2020 by folkert van heusden, released under AGPL v3.0
#pragma once
#include <atomic>
#include <jansson.h>
#include <shared_mutex>
#include <string>

#include "filter.h"
#include "source.h"
#include "target.h"
#include "selection_mask.h"
#include "parameters.h"

class motion_trigger : public interface
{
protected:
	std::map<std::string, parameter *> parameters;

	std::vector<interface *> event_clients;

public:
	motion_trigger(const std::string & id, const std::string & descr, const std::map<std::string, parameter *> & detection_parameters);
	virtual ~motion_trigger();

	virtual bool check_motion() { return false; }

	json_t * get_rest_parameters();
	json_t * rest_set_parameter(const std::string & key, const std::string & value);

	void register_notifier(interface *const i);
	void unregister_notifier(interface *const i);

	virtual void operator()() override;
};
